Index: codes/icosagcm/devel/src/base/grid_param.f90
===================================================================
--- codes/icosagcm/devel/src/base/grid_param.f90	(revision 938)
+++ codes/icosagcm/devel/src/base/grid_param.f90	(revision 939)
@@ -4,5 +4,6 @@
   SAVE
 
-! Some variable are BIND(C) to be accessible from Python                                                                                                                                                   ! They are declared using C sizes
+! Some variables are BIND(C) to be accessible from Python
+! They are declared using C sizes
 
   INTEGER  :: iim_glo=40
Index: codes/icosagcm/devel/src/dynamics/compute_NH_geopot.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_NH_geopot.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_NH_geopot.F90	(revision 939)
@@ -1,4 +1,4 @@
 MODULE compute_NH_geopot_mod
-  USE grid_param, ONLY : llm
+  USE grid_param
   IMPLICIT NONE
   PRIVATE
@@ -136,6 +136,7 @@
     thermo_entropy
   USE disvert_mod, ONLY : ptop
-  USE data_unstructured_mod, ONLY : primal_num,edge_num,dual_num,id_NH_geopot,debug_hevi_solver_, &
-    PHI_BOT,pbot,rho_bot,enter_trace, exit_trace
+  USE data_unstructured_mod, ONLY : enter_trace, exit_trace, &
+       id_NH_geopot,debug_hevi_solver_, &
+       PHI_BOT,pbot,rho_bot
   FIELD_MASS   :: m_ik, theta   ! IN*2
   FIELD_GEOPOT :: m_il, W_il, Phi_il, Phi_star_il  ! IN,INOUT*2, LOCAL
Index: codes/icosagcm/devel/src/dynamics/compute_caldyn_Coriolis.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_caldyn_Coriolis.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_caldyn_Coriolis.F90	(revision 939)
@@ -63,7 +63,8 @@
   SUBROUTINE compute_caldyn_coriolis_unst(hflux,theta,qu, Ftheta, convm,dtheta_rhodz,du)
     USE ISO_C_BINDING, only : C_DOUBLE, C_FLOAT
-    USE data_unstructured_mod, ONLY : id_coriolis, primal_num, dual_num, edge_num, &
-          left, right,primal_deg,primal_edge,primal_ne,trisk_deg,wee,trisk,Ai, &
-          enter_trace, exit_trace
+    USE data_unstructured_mod, ONLY : enter_trace, exit_trace, &
+         id_coriolis, left, right, primal_deg, primal_edge, primal_ne, &
+         trisk_deg, trisk, wee ! FIXME wee
+         
     FIELD_U     :: hflux, Ftheta, qu, du ! IN, BUF, IN, INOUT
     FIELD_MASS  :: convm                 ! BUF
Index: codes/icosagcm/devel/src/dynamics/compute_caldyn_fast.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_caldyn_fast.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_caldyn_fast.F90	(revision 939)
@@ -71,7 +71,6 @@
     USE ISO_C_BINDING, only : C_DOUBLE, C_FLOAT
     USE data_unstructured_mod, ONLY : enter_trace, exit_trace, &
-         id_fast, primal_num, dual_num, edge_num, &
-         dual_deg, dual_edge, dual_ne, dual_vertex, &
-         up, down, left, right, Av, fv, Riv2
+         id_fast, dual_deg, dual_edge, dual_ne, dual_vertex, &
+         up, down, left, right
     NUM, INTENT(IN) :: tau
     FIELD_MASS   :: pk,berni  ! INOUT, OUT
Index: codes/icosagcm/devel/src/dynamics/compute_caldyn_slow_NH.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_caldyn_slow_NH.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_caldyn_slow_NH.F90	(revision 939)
@@ -1,4 +1,4 @@
 MODULE compute_caldyn_slow_NH_mod
-  USE grid_param, ONLY : llm
+  USE grid_param
   IMPLICIT NONE
   PRIVATE
@@ -80,6 +80,6 @@
   SUBROUTINE compute_caldyn_vert_NH_unst(mass,geopot,W,wflux, eta_dot,wcov,W_etadot, du,dPhi,dW)
     USE ISO_C_BINDING, only : C_DOUBLE, C_FLOAT
-    USE data_unstructured_mod, ONLY : left,right,edge_num,primal_num,dual_num,id_vert_NH, &
-        enter_trace, exit_trace
+    USE data_unstructured_mod, ONLY : enter_trace, exit_trace, &
+         id_vert_NH, left,right
     FIELD_MASS   :: mass, eta_dot, wcov, W_etadot ! IN, BUF*3
     FIELD_GEOPOT :: geopot,W,wflux,dPhi,dW ! IN*3, INOUT*2
Index: codes/icosagcm/devel/src/dynamics/compute_caldyn_slow_hydro.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_caldyn_slow_hydro.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_caldyn_slow_hydro.F90	(revision 939)
@@ -55,6 +55,6 @@
   SUBROUTINE compute_caldyn_slow_hydro_unst(zero, u,rhodz,hv,Kv, berni, hflux,du)
     USE ISO_C_BINDING, only : C_DOUBLE, C_FLOAT
-    USE data_unstructured_mod, ONLY :left,right,edge_num,primal_num,dual_num,id_slow_hydro, &
-        primal_deg,le_de,primal_edge,Ai,enter_trace, exit_trace
+    USE data_unstructured_mod, ONLY : enter_trace, exit_trace, &
+         id_slow_hydro, left, right, primal_deg, primal_edge
     LOGICAL, INTENT(IN) :: zero
     FIELD_MASS  :: rhodz, hv, Kv, berni  ! IN, IN, IN, BUF
Index: codes/icosagcm/devel/src/dynamics/compute_caldyn_solver.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_caldyn_solver.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_caldyn_solver.F90	(revision 939)
@@ -1,4 +1,4 @@
 MODULE compute_caldyn_solver_mod
-  USE grid_param, ONLY : llm
+  USE grid_param
   IMPLICIT NONE
   PRIVATE
@@ -93,6 +93,7 @@
   USE grid_param, ONLY : nqdyn
   USE disvert_mod, ONLY : ptop
-  USE data_unstructured_mod, ONLY : id_solver,primal_num,dual_num,edge_num,left, right,PHI_BOT, &
-    enter_trace, exit_trace
+  USE data_unstructured_mod, ONLY : enter_trace, exit_trace, &
+       id_solver, left, right, PHI_BOT
+    
   USE compute_NH_geopot_mod, ONLY : compute_NH_geopot_unst
   NUM, INTENT(IN) :: tau 
Index: codes/icosagcm/devel/src/dynamics/compute_pvort_only.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_pvort_only.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_pvort_only.F90	(revision 939)
@@ -1,4 +1,4 @@
 MODULE compute_pvort_only_mod
-  USE grid_param, ONLY : llm
+  USE grid_param
   IMPLICIT NONE
   PRIVATE
@@ -38,7 +38,7 @@
   SUBROUTINE compute_pvort_only_unst(u,rhodz,qu,qv, hv_)
     USE ISO_C_BINDING, only : C_DOUBLE, C_FLOAT
-    USE data_unstructured_mod, ONLY : enter_trace, exit_trace, &
-         id_pvort_only, primal_num, dual_num, edge_num, &
-         dual_deg, dual_edge, dual_ne, dual_vertex, up, down, Av, fv, Riv2
+    USE geometry, ONLY : Riv2, Av, fv
+    USE data_unstructured_mod, ONLY : enter_trace, exit_trace, id_pvort_only, &
+         dual_deg, dual_edge, dual_ne, dual_vertex, up, down
     FIELD_MASS :: rhodz
     FIELD_U    :: u,qu
Index: codes/icosagcm/devel/src/dynamics/compute_theta.F90
===================================================================
--- codes/icosagcm/devel/src/dynamics/compute_theta.F90	(revision 938)
+++ codes/icosagcm/devel/src/dynamics/compute_theta.F90	(revision 939)
@@ -1,4 +1,4 @@
 MODULE compute_theta_mod
-  USE grid_param, ONLY : llm, nqdyn
+  USE grid_param
   USE disvert_mod, ONLY : mass_dak, mass_dbk, caldyn_eta, eta_mass, ptop
   IMPLICIT NONE
@@ -73,6 +73,5 @@
   SUBROUTINE compute_theta_unst(mass_col,theta_rhodz, rhodz,theta)
     USE ISO_C_BINDING, only : C_DOUBLE, C_FLOAT
-    USE data_unstructured_mod, ONLY : id_theta,primal_num,dual_num,edge_num, &
-         enter_trace, exit_trace
+    USE data_unstructured_mod, ONLY : enter_trace, exit_trace, id_theta
     FIELD_PS :: mass_col
     FIELD_MASS :: rhodz